/*  This file is a part of the program DNetStats.
    DNetStats a linux qt application to monitor network and initiate 
    autoshutdown when connection is cut or idle.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "dialogimpl.h"
//
DialogImpl::DialogImpl( QWidget * parent, Qt::WFlags f) 
	: QDialog(parent, f)
{    count=0;
	//f |=Qt::WindowSystemMenuHint | Qt::WindowMinimizeButtonHint ;
	setupUi(this);	
	buf1=1;
	buf2=1000000;
	idlecounter=0;
	countstr="unknown";
	pathstr="audio.wav";
	
	 x1=0;y1=0;x2=0;y2=50;	
         row=0;column=0,rowcount=1;
         tablenet->insertRow(2);
         //
	connect(bstart, SIGNAL(clicked()), this, SLOT(addClick()));
	connect(bstop, SIGNAL(clicked()), this, SLOT(addShut()));
	connect(bexit, SIGNAL(clicked()), this, SLOT(addExit()));
        connect(bsave, SIGNAL(clicked()), this, SLOT(addSave()));
        connect(tabwid, SIGNAL(currentChanged(int)), this, SLOT(tabactive(int)));
	connect(breset, SIGNAL(clicked()), this, SLOT(addReset()));
	connect(&threadA, SIGNAL(conok()), this, SLOT(chgconok()));
        connect(&threadA, SIGNAL(concut()), this, SLOT(chgconcut()));
        //
        connect(&nthread, SIGNAL(availlist(const QStringList &)), this, SLOT(ntmap_refresh(const QStringList &)));
        connect(&nthread, SIGNAL(fileend()), this, SLOT(fileendslot()));
        //
	 sysv=system("touch spdchk.ld");	 
	 sysv=system("touch tfdmp.ld");
	 //
	 create_msg_box();
         create_sys_tray();
	 //
	 QFile file("savefile.ld");
     if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
     {
                sysv=system("touch savefile.ld");
		cerr<<"\ncan't find savefile,creating one\n";
	}
	QTextStream in(&file);
	  if(!in.atEnd())
	  {
	  spinBox->setValue(in.readLine(8).toInt(&ok,10));
	  sbidle->setValue(in.readLine(8).toInt(&ok,10));
	  sbidlespeed->setValue(in.readLine(8).toInt(&ok,10));
	  comboBox->setCurrentIndex(in.readLine(8).toInt(&ok,10));
	  sbinterval->setValue(in.readLine(8).toInt(&ok,10));
	  lepath->setText(in.readLine(100));
      }
	 file.close();
	 QFile file1("chklog.txt");
	 if (!file1.open(QIODevice::ReadOnly | QIODevice::Text))
     {
     	sysv=system("touch chklog.txt");
     }
           QTextStream in2(&file1);
           telog->setText(in2.readLine(50));
           telog->append(in2.readLine(50));
           telog->append(in2.readLine(50));
           telog->append(in2.readLine(50));
           telog->append("------------------------------------------");
           telog->append("<i>This is the log !<i>");
           file1.close();
    	 gView->setScene(&scene);
	 mfont=QFont ();
	 mfont.setPointSize(8);	
	//line2=QLineF(0,100,250,100 ); 
	 gView->setAlignment((Qt::AlignLeft | Qt::AlignBottom));
	 scene.setSceneRect(0,0,160,50);	 
	 //QRadialGradient gradient(0, 0, 10);
         // gradient.setSpread(QGradient::RepeatSpread);
         gviewshow();
         this->showNormal();
}
//
void DialogImpl::addClick()
{
 count=0;
 
 if(!threadA.isRunning())
 {
  	//
 	threadA.chkstring=QString("ifconfig %1 >spdchk.ld 2>/dev/null")
             .arg(comboBox->currentText());
             
  threadA.interval=sbinterval->value();	
  tedit->setText("Checking connection");
  
  threadA.start();
  
  lcpstatus->setText("Started");
  bstart->setEnabled(false);
  bstop->setEnabled(true);
  tab_2->setDisabled(true); 
  
 }
 
}


void DialogImpl::addShut()
{ 

 tedit->setText("Checkcon stopped!");
 lcpstatus->setText("Stopped"); 
//
    icon =QIcon(":/icons/109.ico");
    trayicon->setIcon(icon);
    trayicon->show();
  
 //
 threadA.terminate();
 threadA.wait();
 sthread.terminate();
	sthread.wait();
 bstart->setEnabled(true);
 bstop->setEnabled(false);
  tab_2->setEnabled(true); 
 
}

void DialogImpl::addExit()
{
   
    threadA.terminate(); 
    threadA.wait();
     sthread.terminate();
	sthread.wait();
        nthread.terminate();
        nthread.wait();
	sysv=system("rm -f spdchk.ld");
	sysv=system("rm -f tfdmp.ld");
	
	
   
    exit(0);
 
}
void DialogImpl::addSave()
{
	QFile file("savefile.ld");
     if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
     {
     	sysv=system("touch savefile.ld");
		cerr<<"\ncan't find savefile,creating one\n";
     }
     QTextStream out(&file);
     out<<spinBox->text()<<"\n";
     out<<sbidle->text()<<"\n";
     out<<sbidlespeed->text()<<"\n";
     out<<comboBox->currentIndex()<<"\n";
     out<<sbinterval->text()<<"\n"; 
     out<<lepath->text()<<"\n"; 
     
     file.close();
}
void DialogImpl::addReset()
{
			spinBox->setValue(20);
	  sbidle->setValue(2);
	  sbidlespeed->setValue(5);
	  sbinterval->setValue(2);
}
	
void DialogImpl::chgconok()
{	
	if(sthread.isRunning())
        {
			sthread.terminate();
	       sthread.wait();
         }
         lstatus->setText("Connected");
	count=count+threadA.interval; //counting time
	tedit->setText("Connection OK!");
	//
	icon =QIcon(":/icons/109-2.ico");
    trayicon->setIcon(icon);
    trayicon->show();
	//
	QPen pen(Qt::green,1);
    line3=QLineF(x1,y1,x2,y2 ); 
    
    gView->show();
    if(x1>=138)
    {
    	x1=0;
    	scene.clear();
    	gviewshow();
    }
    x1=x1+1;
    x2=x1;
    y1=2*(25-((cspeed/8)%25));
    scene.addLine(line3,pen);

    countstr=QString("%1h:%2m:%3s")
             .arg((count/3600), 0, 10)
             .arg(((count/60)%60), 0, 10)
             .arg((count%60), 0, 10);
	 //
    buf1=threadA.rxBytes.toInt(&ok,10);
    cspeed=((buf1-buf2)*8)/(threadA.interval*1024);
    lcdnum->display(cspeed);
    if(cbidle->isChecked())
    {
          if(cspeed<(sbidlespeed->value()))
	      {	idlecounter++; 	}
          else
              { idlecounter=0; }
          if((idlecounter*threadA.interval) >= (sbidle->value()*60))//when idlecounter exceeds the time shutown takes place
	       {
	    	initshut("connection idle");
	        std::cerr<<"idle";	
                }
     }
    buf2=buf1;
    lvdown=buf1;
    vdown=lvdown/(1024*1024);
    ldown->setText((QString::number(vdown,'f',2)).append(" MB"));
    lcount->setText(countstr);
	
}
void DialogImpl::chgconcut()
{    
    gviewshow();
    lstatus->setText("Terminated");
    tedit->setText("Connection Terminated!");
    icon =QIcon(":/icons/109.ico");
    trayicon->setIcon(icon);
    trayicon->show();
        //bstart->setEnabled(true);
    if(cbmusic->isChecked())
        {
                pathstr=QString("xterm -e 'play %1'")
                            .arg(lepath->text());			
        sysv=system(pathstr.toLocal8Bit().constData());
			
        }
	if(cbshut->isChecked())
		
	{   
	 initshut("connection cut");
	}
	 cbmusic->setChecked(false);
	 bstop->setEnabled(true);
			
}
void DialogImpl::gviewshow()
{	 QPen pen(Qt::gray,1);
	 pen.setStyle(Qt::DotLine);
	 pen.setCapStyle(Qt::RoundCap);
	 line1=QLineF(0,13.5,180,13.5 );
         scene.addLine(line1,pen);
         line4=QLineF(0,25.5,180,25.5 );
         scene.addLine(line4,pen);
         line5=QLineF(0,37.5,180,37.5);
         scene.addLine(line5,pen);
	  //scene.addText((QString::number((cspeed/8),'f',0)).append("KB/s"),mfont);
	 QRadialGradient gradient(100, 100, 150, 50, 50);
     gradient.setColorAt(0, QColor::fromRgbF(0, 0, 0, 1));
     gradient.setColorAt(1, QColor::fromRgbF(0, 0, 0, 0));
     gradient.setCenter(0,0);
     scene.setBackgroundBrush(gradient);
     scene.setForegroundBrush(QBrush(Qt::gray, Qt::Dense6Pattern));        
	 gView->show();
}
void DialogImpl::initshut(QString reason="unknown")
{
	ctime= QDateTime::currentDateTime();
	tedit->append("Checkcon stopped for shutdown!");
	    threadA.terminate();
	     threadA.wait();
             lcpstatus->setText("Stopped");
//Saving the log
	    tedit->append("Saving to log chklog.txt");
     QFile file("chklog.txt");
     if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
      {
      	cerr<<"\ncan't find chklog\n";
	   }
     QTextStream out(&file);
     out<<"The connection lasted:- "<<countstr<<"\n";
     out<<"Reason:- "<<reason<<"\n";
     out<<"Downloaded:- "<<(QString::number(vdown,'f',2)).append(" MB")<<"\n";
     out<<"Time:- "<<ctime.toString("h:m:s ap ddd MMMM yy")<<"\n";     
     file.close();
	// 
	
	sthread.shuttime=spinBox->value();
	sstr=QString("The System is going down in %1 second.!!!")
             .arg(sthread.shuttime, 0, 10);
	tedit->append(sstr);
	tedit->append("Check Terminal for countdown.");
	tedit->append("You must be root!");
	sthread.start(); 
	msgBox.setText(QString(" <h3>The system is going down in %1 seconds         </h3>").arg((sthread.shuttime), 0, 10));
	msgBox.setInformativeText(QString("<i>Reason:%1. %2</i>").arg(reason,QString("Press 'Abort' button to cancel.")));
	ret=msgBox.exec();	 
	if(ret==262144)
      {
      	sthread.terminate();
        sthread.wait();
        tedit->clear();
        bstop->setDisabled(true);
        bstart->setEnabled(true);
        tab_2->setEnabled(true);
     }
     else if(ret==1024)
        {
            bstop->setDisabled(true);
            bstart->setEnabled(true);
            tab_2->setEnabled(true); 
     	 sysv=system("init 0");
     	 idlecounter=0;
    	}
}

void DialogImpl::tray_icon_click(QSystemTrayIcon::ActivationReason areason)
{
  switch (areason) {
     case QSystemTrayIcon::Trigger:  
     if (this->isHidden())
    {
          
        this->show();
        setVisible(true);
        activateWindow();
        QWidget::setWindowState(Qt::WindowActive);
    }
    else
    {        
        this->hide();
    }
    break;
     case QSystemTrayIcon::DoubleClick:
          break;
     case QSystemTrayIcon::MiddleClick:         
         break;
     default:
         ;
     }

    
}

void DialogImpl::closeEvent(QCloseEvent *event)
{
    threadA.stop();    
    threadA.wait();
    sthread.terminate();
    sthread.wait();  
    nthread.terminate();
    nthread.wait();
    
    sysv=system("rm -f spdchk.ld");    
    sysv=system("rm -f tfdmp.ld");
    event->accept();     
    
}
void DialogImpl::create_msg_box()
{
	msgBox.setTextFormat(Qt::RichText);   
        msgBox.setStandardButtons(QMessageBox::Ok | QMessageBox::Abort);
 	msgBox.setDefaultButton(QMessageBox::Abort);
 	msgBox.setWindowTitle("Shutdown");
 	msgBox.setIcon(QMessageBox::Warning);
}

void DialogImpl:: create_sys_tray()
{
	icon =QIcon(":/icons/109.ico");
 if(icon.isNull())
 {
 	tedit->setText("icon null");
 }
//
    trayicon = new QSystemTrayIcon(this);
    connect(trayicon, SIGNAL(activated(QSystemTrayIcon::ActivationReason)), this, SLOT(tray_icon_click(QSystemTrayIcon::ActivationReason)));
    stmenu = new QMenu(this);
    //
     minimizeAction = new QAction(tr("Mi&nimize"), this);
     minimizeAction->setIcon(QIcon(":/icons/minim.ico"));
     connect(minimizeAction, SIGNAL(triggered()), this, SLOT(hide()));

     maximizeAction = new QAction(tr("M&aximise"), this);
     maximizeAction->setIcon(QIcon(":/icons/maxim.ico"));
     connect(maximizeAction, SIGNAL(triggered()), this, SLOT(showNormal()));

     quitAction = new QAction(tr("&Quit"), this);
     quitAction->setIcon(QIcon(":/icons/quit.ico"));
    connect(quitAction, SIGNAL(triggered()), this, SLOT(addExit()));
   //
     if(!QSystemTrayIcon::isSystemTrayAvailable())
     {
     	cout<<"tray icon not found";
     	
     }
     
     stmenu->addAction(maximizeAction);
     stmenu->addAction(minimizeAction);    
     stmenu->addSeparator();
     stmenu->addAction(quitAction);
     	trayicon->setContextMenu(stmenu);
         trayicon->setIcon(icon);
     	//trayicon->setVisible(true);
     	trayicon->setToolTip("DNetStats");
        setWindowIcon(icon);    	 
    	trayicon->show();
    
	 //  
}
void DialogImpl::tabactive(int index)
{
    if(index==1)
    {
        tablenet->clearContents();
        tablenet->removeRow(tablenet->rowCount());
        row=0;
        rowcount=1;
        nthread.start();

    }
    else
    {
        nthread.terminate();
        nthread.wait();
    }


}
//
void DialogImpl::ntmap_refresh(const QStringList list)
{
           tablenet->setRowCount(row+1);
          // cout<< list.at(6).toLocal8Bit().constData() << endl;
           newItem = new QTableWidgetItem(list.at(6),0);
           tablenet->setItem(row, column, newItem);
           newItem = new QTableWidgetItem(list.at(3),0);
           tablenet->setItem(row, column+1, newItem);
           newItem = new QTableWidgetItem(list.at(4),0);
           tablenet->setItem(row, column+2, newItem);
           row++;
   this->show();
 }

void DialogImpl::fileendslot()
{
        tablenet->removeRow(tablenet->rowCount());
        tablenet->clearContents();
        row=0;
        rowcount=1;
}





